> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chainloop.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List environments

> Retrieves a paginated list of environments with optional filtering by name or description.



## OpenAPI

````yaml https://api.app.chainloop.dev/openapi.yaml get /v1/environments
openapi: 3.0.1
info:
  contact:
    email: support@chainloop.dev
    name: Chainloop Support
    url: https://chainloop.dev
  termsOfService: https://chainloop.dev/terms
  title: Chainloop Platform API
  version: '1.0'
servers:
  - url: https://api.app.chainloop.dev/
security:
  - bearerToken: []
tags:
  - description: AI-powered agent operations
    name: AgentsService
  - name: ArtifactService
  - name: AssessmentService
  - description: Service for polling the status of asynchronous operations
    name: AsyncOperationsService
  - name: AttestationsService
  - name: PolicyService
  - name: ComplianceService
  - name: ComponentService
  - name: EnvironmentsService
  - name: EvidenceService
  - name: FindingService
  - name: LogicalEnvironmentsService
  - name: ProductsService
  - name: ProjectsService
  - name: UserService
externalDocs:
  description: Chainloop Official Documentation
  url: https://docs.chainloop.dev
paths:
  /v1/environments:
    get:
      tags:
        - EnvironmentsService
      summary: List environments
      description: >-
        Retrieves a paginated list of environments with optional filtering by
        name or description.
      operationId: EnvironmentsService_List
      parameters:
        - description: >-
            The (zero-based) offset of the first item returned in the
            collection.
          in: query
          name: pagination.page
          schema:
            format: int32
            type: integer
        - description: >-
            The maximum number of entries to return. If the value exceeds the
            maximum, then the maximum value will be used.
          in: query
          name: pagination.page_size
          schema:
            format: int32
            type: integer
        - description: >-
            Query string to search across environment name and description
            (case-insensitive)
          in: query
          name: query
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1EnvironmentsServiceListResponse'
          description: A successful response.
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1BadRequestResponse'
          description: Bad Request - The request was invalid or cannot be served.
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1UnauthorizedResponse'
          description: Unauthorized - Authentication is required.
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1PermissionDeniedResponse'
          description: Forbidden - You do not have permission to access this resource.
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1InternalServerErrorResponse'
          description: Internal Server Error - An unexpected error occurred on the server.
        default:
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
          description: An unexpected error response.
components:
  schemas:
    v1EnvironmentsServiceListResponse:
      example:
        pagination:
          total_count: 4
          page: 3
          total_pages: 7
          page_size: 2
        environments:
          - updated_at: '2000-01-23T04:56:07.000Z'
            organization_id: organization_id
            name: name
            description: description
            created_at: '2000-01-23T04:56:07.000Z'
            id: id
            type: ENVIRONMENT_TYPE_UNSPECIFIED
          - updated_at: '2000-01-23T04:56:07.000Z'
            organization_id: organization_id
            name: name
            description: description
            created_at: '2000-01-23T04:56:07.000Z'
            id: id
            type: ENVIRONMENT_TYPE_UNSPECIFIED
      properties:
        environments:
          items:
            $ref: '#/components/schemas/v1Environment'
          title: Environments is the list of environments
          type: array
        pagination:
          $ref: '#/components/schemas/v1OffsetPaginationResponse'
      title: >-
        EnvironmentsServiceListResponse is the response message for listing
        environments
      type: object
    v1BadRequestResponse:
      description: Response for bad request
      example:
        code: 0
        details:
          - details
          - details
        message: message
      properties:
        code:
          default: 3
          description: >-
            The error code indicating the type of error. It's fixed to 3, which
            is the code for INVALID_ARGUMENT.
          format: int32
          type: integer
        message:
          description: A human-readable message providing more details about the error.
          type: string
        details:
          description: Additional details about the error.
          items:
            type: string
          type: array
      required:
        - code
        - message
      title: BadRequestResponse
      type: object
    v1UnauthorizedResponse:
      description: Response for unauthorized access
      example:
        code: 6
        details:
          - details
          - details
        message: message
      properties:
        code:
          default: 16
          description: >-
            The error code indicating the type of error. It's fixed to 16, which
            is the code for UNAUTHENTICATED.
          format: int32
          type: integer
        message:
          description: A human-readable message providing more details about the error.
          type: string
        details:
          description: Additional details about the error.
          items:
            type: string
          type: array
      required:
        - code
        - message
      title: UnauthorizedResponse
      type: object
    v1PermissionDeniedResponse:
      description: Response for permission denied
      example:
        code: 1
        details:
          - details
          - details
        message: message
      properties:
        code:
          default: 7
          description: >-
            The error code indicating the type of error. It's fixed to 7, which
            is the code for PERMISSION_DENIED.
          format: int32
          type: integer
        message:
          description: A human-readable message providing more details about the error.
          type: string
        details:
          description: Additional details about the error.
          items:
            type: string
          type: array
      required:
        - code
        - message
      title: PermissionDeniedResponse
      type: object
    v1InternalServerErrorResponse:
      description: Response for internal server error
      example:
        code: 5
        details:
          - details
          - details
        message: message
      properties:
        code:
          default: 13
          description: >-
            The error code indicating the type of error. It's fixed to 13, which
            is the code for INTERNAL_ERROR.
          format: int32
          type: integer
        message:
          description: A human-readable message providing more details about the error.
          type: string
        details:
          description: Additional details about the error.
          items:
            type: string
          type: array
      required:
        - code
        - message
      title: InternalServerErrorResponse
      type: object
    rpcStatus:
      example:
        code: 5
        details:
          - '@type': '@type'
          - '@type': '@type'
        message: message
      properties:
        code:
          format: int32
          type: integer
        message:
          type: string
        details:
          items:
            $ref: '#/components/schemas/protobufAny'
          type: array
      type: object
    v1Environment:
      example:
        updated_at: '2000-01-23T04:56:07.000Z'
        organization_id: organization_id
        name: name
        description: description
        created_at: '2000-01-23T04:56:07.000Z'
        id: id
        type: ENVIRONMENT_TYPE_UNSPECIFIED
      properties:
        id:
          title: ID is the unique identifier of the environment
          type: string
        name:
          title: Name is the name of the environment (DNS-1123 compliant)
          type: string
        description:
          title: Description is a detailed explanation of the environment
          type: string
        organization_id:
          title: >-
            OrganizationID is the unique identifier of the organization that
            owns the environment
          type: string
        type:
          $ref: '#/components/schemas/v1EnvironmentType'
        created_at:
          format: date-time
          title: CreatedAt is the time when the environment was created
          type: string
        updated_at:
          format: date-time
          title: UpdatedAt is the time when the environment was last updated
          type: string
      title: Environment represents an environment entity
      type: object
    v1OffsetPaginationResponse:
      example:
        total_count: 4
        page: 3
        total_pages: 7
        page_size: 2
      properties:
        page:
          format: int32
          title: The current page number
          type: integer
        page_size:
          format: int32
          title: The number of results per page
          type: integer
        total_count:
          format: int32
          title: The total number of results
          type: integer
        total_pages:
          format: int32
          title: The total number of pages
          type: integer
      title: OffsetPaginationResponse is used to return the pagination information
      type: object
    protobufAny:
      additionalProperties:
        type: object
      example:
        '@type': '@type'
      properties:
        '@type':
          type: string
      type: object
    v1EnvironmentType:
      default: ENVIRONMENT_TYPE_UNSPECIFIED
      enum:
        - ENVIRONMENT_TYPE_UNSPECIFIED
        - ENVIRONMENT_TYPE_KUBERNETES
        - ENVIRONMENT_TYPE_ECS
        - ENVIRONMENT_TYPE_SERVER
        - ENVIRONMENT_TYPE_LAMBDA
        - ENVIRONMENT_TYPE_CUSTOM
      title: EnvironmentType defines the type of environment
      type: string
  securitySchemes:
    bearerToken:
      description: Bearer token for authentication
      type: http
      scheme: bearer
      bearerFormat: JWT

````